% Copyright (c) 2008, Magdalena Sigg, Wanja Chresta
% All rights reserved.
%
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are met:
%     * Redistributions of source code must retain the above copyright
%       notice, this list of conditions and the following disclaimer.
%     * Redistributions in binary form must reproduce the above copyright
%       notice, this list of conditions and the following disclaimer in the
%       documentation and/or other materials provided with the distribution.
%     * Neither the name of the <organization> nor the
%       names of its contributors may be used to endorse or promote products
%       derived from this software without specific prior written permission.
%
% THIS SOFTWARE IS PROVIDED BY <copyright holder> ``AS IS'' AND ANY
% EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
% DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
% (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
% SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

clear all;
clf;

% N=2^5;
N=2^3;

x=(-N/2:N/2-1)';
x=2*pi/N*x;
h=2*pi/length(x);

% t=0; tmax=0.1;
t=0; tmax=5;
dt=0.01/N^2;

% Anfangsbedingung:
u=pi*sqrt(2)*(1+0.1*cos(x));

% Ableitungsmatrix:
col2 = [-pi^2/(3*h^2)-1/6 -0.5*(-1).^(1:N-1).*csc(0.5*h*(1:N-1)).^2 ];
col2 =col2';
D2 = toeplitz(col2, col2([1 N:-1:2]));

it=1;

figure(1);

f = inline("i*D2*u+i*2*abs(u).^2.*u","u");

while (t<tmax)
    t=t+dt;
    
	u = rk4step(f,dt,u);
    % RK4 in der Zeit:
	%k1=i*D2*u+i*abs(u).^2.*u;
    %uk2=u+dt.*k1/2;
    %k2=i*D2*uk2+i*abs(uk2).^2.*uk2;
    %uk3=u+dt.*k2./2;
    %k3=i*D2*uk3+i*abs(uk3).^2.*uk3;
    %uk4=u+dt.*k3;
    %k4=i*D2*uk4+i*abs(uk4).^2.*uk4;
    %unew=u+dt.*(k1+2.*(k2+k3)+k4)./6;
    %u=unew;
    
    if mod(it,20)==0
        % Interpolation der Lsung:
        hi=2*pi/1000;
        xi=-pi:hi:pi;
        ui=spline([x;pi],[u;u(1)],xi);
        plot(xi,abs(ui).^2);
        title(num2str(t));
        xlabel('x'); ylabel('|u|^2');
        axis([-pi,pi,0,60]);
        pause(0.001);
    end 

    it=it+1;
    
end
